%global major_version 44
%global minor_version 0

%global gettext_version                         0.19.6
%global gnome_desktop_version                   43
%global glib2_version                           2.68.0
%global gtk4_version                            3.24.27
%global mutter_version                          44.3
%global gsettings_desktop_schemas_version       42
%global ibus_version                            1.5.24
%global gnome_settings_daemon_version           43

%bcond_with firefox

Summary:        Window management and application launching for GNOME
Name:           gnome-kiosk
Version:        %{major_version}.%{minor_version}
Release:        1%{?dist}
License:        GPLv2+
URL:            https://gitlab.gnome.org/GNOME/gnome-kiosk
Source0:        https://download.gnome.org/sources/%{name}/%{major_version}/%{name}-%{major_version}.%{minor_version}.tar.xz

BuildRequires:  gcc meson git
BuildRequires:  dconf desktop-file-utils
BuildRequires:  gettext >= %{gettext_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gobject-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gio-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gnome-desktop-3.0) >= %{gnome_desktop_version}
BuildRequires:  pkgconfig(gtk4) >= %{gtk4_version}
BuildRequires:  pkgconfig(ibus-1.0) >= %{ibus_version}
BuildRequires:  pkgconfig(libmutter-12) >= %{mutter_version}
BuildRequires:  mesa-libEGL-devel
BuildRequires:  mesa-libGL-devel
Requires:       gnome-settings-daemon >= %{gnome_settings_daemon_version}
Requires:       gsettings-desktop-schemas >= %{gsettings_desktop_schemas_version}
Provides:       firstboot(windowmanager) = %{name}

%description
GNOME Kiosk provides a desktop enviroment suitable for fixed purpose, or
single application deployments like wall displays and point-of-sale systems.


%if %{with firefox}
%package search-appliance
Summary:        Example search application that uses GNOME Kiosk
License:        GPLv2+
Requires:       %{name} = %{version}-%{release}
Requires:       firefox
Requires:       gnome-session
BuildArch:      noarch

%description search-appliance
This package provides a full screen firefox window pointed to google.
%endif


%package script-session
Summary:        Basic session used for running kiosk application from shell script
License:        GPLv2+
Requires:       %{name} = %{version}-%{release}
Requires:       gnome-session
Recommends:     gedit
BuildArch:      noarch

%description script-session
This package generates a shell script and the necessary scaffolding to start that shell script within a kiosk session.


%prep
%autosetup -S git -n %{name}-%{major_version}.%{minor_version}


%build
%meson
%meson_build


%install
%meson_install

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/org.gnome.Kiosk.desktop
desktop-file-validate %{buildroot}%{_datadir}/applications/org.gnome.Kiosk.SearchApp.desktop


%files
%license COPYING
%doc README.md
%{_bindir}/gnome-kiosk
%{_datadir}/applications/org.gnome.Kiosk.desktop
%{_datadir}/dconf/profile/gnomekiosk
%{_datadir}/gnome-kiosk/gnomekiosk.dconf.compiled
%{_userunitdir}/org.gnome.Kiosk.target
%{_userunitdir}/org.gnome.Kiosk@wayland.service
%{_userunitdir}/org.gnome.Kiosk@x11.service


%if %{with firefox}
%files -n gnome-kiosk-search-appliance
%{_datadir}/applications/org.gnome.Kiosk.SearchApp.desktop
%{_datadir}/gnome-session/sessions/org.gnome.Kiosk.SearchApp.session
%{_datadir}/xsessions/org.gnome.Kiosk.SearchApp.Session.desktop
%{_datadir}/wayland-sessions/org.gnome.Kiosk.SearchApp.Session.desktop
%else
%exclude %{_datadir}/applications/org.gnome.Kiosk.SearchApp.desktop
%exclude %{_datadir}/gnome-session/sessions/org.gnome.Kiosk.SearchApp.session
%exclude %{_datadir}/xsessions/org.gnome.Kiosk.SearchApp.Session.desktop
%exclude %{_datadir}/wayland-sessions/org.gnome.Kiosk.SearchApp.Session.desktop
%endif


%files -n gnome-kiosk-script-session
%{_bindir}/gnome-kiosk-script
%{_userunitdir}/gnome-session@gnome-kiosk-script.target.d/session.conf
%{_userunitdir}/org.gnome.Kiosk.Script.service
%{_datadir}/applications/org.gnome.Kiosk.Script.desktop
%{_datadir}/gnome-session/sessions/gnome-kiosk-script.session
%{_datadir}/wayland-sessions/gnome-kiosk-script-wayland.desktop
%{_datadir}/xsessions/gnome-kiosk-script-xorg.desktop


%changelog
* Wed Sep 13 2023 rockerzhu <rockerzhu@tencent.com> - 44.0-1
- Update to 44.0 due to mutter already 44.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 43.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 43.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 43.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Dec 05 2022 rockerzhu <rockerzhu@tencent.com> - 43.0-1
- Initial build
